package com.mobula.sample

import android.app.Activity
import android.content.Intent
import android.os.Bundle
import android.view.View
import android.widget.Toast
import com.duapps.ad.DuNativeAd
import com.duapps.ad.PullRequestController
import com.duapps.ad.list.DuNativeAdsManager
import kotlinx.android.synthetic.main.main_layout.*


/**
 * the main page 主页
 *
 * @author mobula team
 */
class MainKotlinActivity : Activity(), View.OnClickListener {

    /**
     * ad recommend id 广告推荐位
     */
    private val PID = 10032
    /**
     * cache data size 缓存大小
     */
    private val CACHESZIE = 2
    /**
     * cache data list size 广告list列表缓存大小
     */
    private val CACHESZIELIST = 10
    /**
     * mobula ad data mobula广告数据类
     */
    private var nativeAd: DuNativeAd? = null
    /**
     * mobula ad data list mobula广告数据列表类
     */
    private var adsManager: DuNativeAdsManager? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.main_layout)
        initListeners()
    }

    /**
     * register to listen event method 注册监听事件
     */
    private fun initListeners() {
        fill_ad.setOnClickListener(this)
        show_ad.setOnClickListener(this)
        list_ad.setOnClickListener(this)
        clean_ad.setOnClickListener(this)
    }

    override fun onClick(v: View) {
        when (v.id) {
            R.id.fill_ad -> {
                nativeAd = DuNativeAd(this, PID, CACHESZIE).apply {
                    fill()
                }
                adsManager = DuNativeAdsManager(this, PID, CACHESZIELIST).apply {
                    fill()
                }
                Toast.makeText(this, "Fill the advertising", Toast.LENGTH_LONG).show()
            }

            R.id.show_ad -> {
                val intent = Intent(this, ShowAdKotlinActivity::class.java)
                startActivity(intent)
            }
            R.id.list_ad -> {
                val listIntent = Intent(this, ListAdKotlinActivity::class.java)
                startActivity(listIntent)
            }
            R.id.clean_ad -> {
                PullRequestController.getInstance(applicationContext).clearCache()
                Toast.makeText(this, "clean cache data success", Toast.LENGTH_LONG).show()
            }

            else -> {
            }
        }
    }
}
