package com.mobula.sample

import android.app.Activity
import android.os.Bundle
import android.util.Log
import android.view.View
import android.widget.*
import android.widget.FrameLayout.LayoutParams
import com.duapps.ad.AdError
import com.duapps.ad.DuAdListener
import com.duapps.ad.DuNativeAd
import com.google.android.gms.ads.formats.MediaView
import com.google.android.gms.ads.formats.NativeAppInstallAdView
import com.google.android.gms.ads.formats.NativeContentAdView
import com.mobula.sample.util.ImageLoaderKotlinHelper
import com.nostra13.universalimageloader.core.ImageLoader

/*
 AdMob 广告专用
 Special Activty for AdMob
 */

class ShowADCardKotlinActivity : Activity() {


    private val TAG = "ShowADCardKotlinActivity"
    private val PID = 11279
    private val DEFAULT_CACHE_SIZE = 2
    var nativeAd: DuNativeAd? = null
    lateinit var imageLoader: ImageLoader
    private var titleView: TextView? = null
    private var iconView: ImageView? = null
    private var ratingView: RatingBar? = null
    private var descView: TextView? = null
    private var bigImgView: ImageView? = null
    private var mediaview: MediaView? = null
    private var btnView: TextView? = null
    private var bigImgContainer: RelativeLayout? = null
    private var contentAdView: NativeContentAdView? = null
    private var installAdView: NativeAppInstallAdView? = null
    private var rl: RelativeLayout? = null
    private var fl: FrameLayout? = null
    private var lp: LayoutParams? = null
    internal var mListener: DuAdListener = object : DuAdListener {

        override fun onError(ad: DuNativeAd, error: AdError) {
            Log.d(TAG, "onError : ${error.errorCode}")
        }

        override fun onClick(ad: DuNativeAd) {
            Log.d(TAG, "onClick : click ad")
        }

        override fun onAdLoaded(ad: DuNativeAd) {
            Log.d("TAG", "onAdLoaded: ${ad.adChannelType}")
            runOnUiThread {
                if (ad != null) {
                    fl!!.removeAllViews()
                }
                Log.d(TAG, "ad 渠道号:  ${ad.adChannelType}" )
                titleView!!.text = ad.title
                ratingView!!.rating = ad.ratings
                imageLoader.displayImage(ad.iconUrl, iconView!!)
                imageLoader.displayImage(ad.imageUrl, bigImgView!!)
                descView!!.text = ad.shortDesc
                btnView!!.text = ad.callToAction

                // If the type of Ad is “Admob- AppInstall”, then dynamically use the “NativeAppInstallAdView” provided by Admob
                //判断广告类型,如果是Admob的AppInstall类型广告,则动态使用Admob提供的NativeAppInstallAdView

                if (ad.adChannelType == DuNativeAd.CHANNEL_TYPE_AM_INSTALL) {
                    Log.d(TAG, "ad CHANNEL_TYPE_AM_INSTALL++++++++")
                    if (lp == null) {
                        lp = LayoutParams(LayoutParams.WRAP_CONTENT,
                                LayoutParams.WRAP_CONTENT)
                    }
                    if (installAdView == null) {
                        installAdView = NativeAppInstallAdView(this@ShowADCardKotlinActivity)
                    }
                    installAdView!!.headlineView = titleView
                    installAdView!!.iconView = iconView
                    installAdView!!.bodyView = descView
                    installAdView!!.mediaView = mediaview
                    installAdView!!.starRatingView = ratingView
                    installAdView!!.callToActionView = btnView
                    installAdView!!.addView(rl, lp)
                    fl!!.addView(installAdView)
                    mediaview?.visibility=View.VISIBLE
                    bigImgView?.visibility=View.GONE

                    /* When registering the View of Ad in type  “Admob- AppInstall”, “NativeAppInstallAdView” need to be registered.
                         * Otherwise, clicking the Ad will be failed and the impression of Ad will be invalid.
                         */
                    /*注册admob AppInstall类型广告View的时候,需要注册NativeAppInstallAdView,
                         *否则广告无法点击跳转,此展示无效.
                         */
                    nativeAd!!.registerViewForInteraction(installAdView)

                } else if (ad.adChannelType == DuNativeAd.CHANNEL_TYPE_AM_CONTENT) {
                    Log.d(TAG, "ad CHANNEL_TYPE_AM_CONTENT++++++++")
                    if (lp == null) {
                        lp = LayoutParams(LayoutParams.WRAP_CONTENT,
                                LayoutParams.WRAP_CONTENT)
                    }
                    if (contentAdView == null) {
                        contentAdView = NativeContentAdView(this@ShowADCardKotlinActivity)
                    }
                    contentAdView!!.headlineView = titleView
                    contentAdView!!.logoView = iconView
                    contentAdView!!.bodyView = descView
                    contentAdView!!.mediaView = mediaview
                    contentAdView!!.callToActionView = btnView
                    contentAdView!!.addView(rl, lp)
                    fl!!.addView(contentAdView)

                    mediaview?.visibility=View.VISIBLE
                    bigImgView?.visibility=View.GONE

                    /* When registering the View of Ad in type  “Admob- Content”, “NativeContentAdView” need to be registered.
                         * Otherwise, clicking the Ad will be failed and the impression of Ad will be invalid.
                         */
                    /*注册admob content类型广告View的时候,需要注册NativeContentAdView,
                         *否则广告无法点击跳转,此展示无效.
                         */

                    nativeAd!!.registerViewForInteraction(contentAdView)
                } else {
                    mediaview?.visibility=View.GONE
                    bigImgView?.visibility=View.VISIBLE
                    fl!!.addView(rl)
                    nativeAd!!.registerViewForInteraction(bigImgContainer)
                }// If the type of Ad is “Facebook” or “DU”, please use the below method to register the View.
                // 广告类型是DuNativeAd.DAP_NORMAL_AD( FB & DU )的时候,请按下面方式注册广告View.
                // If the type of AD is “Admob- Content”, then dynamically use the  “NativeContentAdView” provided by Admob
                //判断广告类型,如果是admob的content类型广告,则动态使用admob提供的NativeContentAdView
            }
        }
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.ad_container_layout)
        fl = findViewById<View>(R.id.adlayout) as FrameLayout?
        initView()

        imageLoader = ImageLoaderKotlinHelper.getInstance(applicationContext)
        nativeAd = DuNativeAd(this, PID, DEFAULT_CACHE_SIZE)
        nativeAd!!.setMobulaAdListener(mListener)

        if (null != nativeAd) {
            nativeAd!!.load()
        }
    }

    private fun initView() {
        rl = layoutInflater.inflate(R.layout.ad_card_item_layout, fl, false) as RelativeLayout
        titleView = rl!!.findViewById<View>(R.id.card_name) as TextView?
        iconView = rl!!.findViewById<View>(R.id.card_icon) as ImageView?
        ratingView = rl!!.findViewById<View>(R.id.card_rating) as RatingBar?
        descView = rl!!.findViewById<View>(R.id.card__des) as TextView?
        bigImgView = rl!!.findViewById<View>(R.id.card_image) as ImageView?
        mediaview = rl!!.findViewById<View>(R.id.card_mediaview) as MediaView?
        btnView = rl!!.findViewById<View>(R.id.card_btn) as TextView?
        bigImgContainer = rl!!.findViewById<View>(R.id.big_ad) as RelativeLayout?
    }

    override fun onResume() {
        // TODO Auto-generated method stub
        super.onResume()
    }

    override fun onDestroy() {
        super.onDestroy()
        nativeAd!!.destory()
    }

}
